﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9
@EndOfDesignText@
Sub Class_Globals
	Private DetailsDialog As CustomLayoutDialog
	Private WebView1 As WebView
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	' 
End Sub


Sub TestDialog As ResumableSub
	
	
	Dim sf As Object = DetailsDialog.ShowAsync("Testdialog", "OK", "Cancel", "", Null, True)
	DetailsDialog.SetSize(100%x, 100%y)
	Wait For (sf) Dialog_Ready(Dialogpanel As Panel)
	
	WebView1.Initialize("WebView1")
	Dialogpanel.Addview(WebView1, 0, 0, Dialogpanel.Width, Dialogpanel.Height)

	WebView1.LoadUrl("https://www.b4x.com")

	Wait For (sf) Dialog_Result(res As Int)
	
	Return res
End Sub


Sub ContextMenu_Create(ActionMode As JavaObject, FocusedView As View)
	Dim menu As JavaObject = ActionMode.RunMethod("getMenu", Null)
	menu.RunMethod("clear", Null)
	Dim event As Object = menu.CreateEvent("android.view.MenuItem.OnMenuItemClickListener", "ContextMenuClick", True)
	
	For Each s As String In Array("Set As Title", "Delete") 'menu items here
		menu.RunMethodJO("add", Array(s)).RunMethod("setOnMenuItemClickListener", Array(event))
	Next

	Wait For ContextMenuClick_Event (MethodName As String, Args() As Object)
	
	Dim MenuItem As JavaObject = Args(0)
	Dim title As String = MenuItem.RunMethod("getTitle", Null)
	Log(title & " was clicked!") '<---- do what ever you like with the click!!!
	If FocusedView Is EditText Then
		Dim et As EditText = FocusedView
		Dim jo As JavaObject = Me
		Dim selectionLength As Int = jo.RunMethod("getSelectionLength", Array(et)) 'will be available in the next version of B4A!
		Dim selectionStart As Int = et.SelectionStart
		Select title
			Case "Set As Title"
				'Activity.Title = et.Text.SubString2(selectionStart, selectionLength + selectionStart)
				Log("  x54 --> " & et.Text.SubString2(selectionStart, selectionLength + selectionStart))
			Case "Delete"
				et.Text = et.Text.SubString2(0, selectionStart) & _
					et.Text.SubString(selectionStart + selectionLength)
		End Select
		
	End If
	
	ActionMode.RunMethod("finish", Null)
End Sub


#if Java
 
 import android.view.*;
 import anywheresoftware.b4a.AbsObjectWrapper;
 import android.text.Selection;
 import android.widget.EditText;

    @Override
    public void onActionModeStarted(ActionMode mode) {
		processBA.raiseEvent(this, "contextmenu_create", AbsObjectWrapper.ConvertToWrapper(new anywheresoftware.b4j.object.JavaObject(), mode),
			AbsObjectWrapper.ConvertToWrapper(new anywheresoftware.b4a.objects.ConcreteViewWrapper(), getCurrentFocus()));
        super.onActionModeStarted(mode);
    }

    @Override
    public void onActionModeFinished(ActionMode mode) {
        super.onActionModeFinished(mode);
    }
	public static int getSelectionLength(EditText et) {
		return Selection.getSelectionEnd(et.getText()) - Selection.getSelectionStart(et.getText());
	}

#End If


